'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactAtomValidationText = require('@s-ui/react-atom-validation-text');

var _reactAtomValidationText2 = _interopRequireDefault(_reactAtomValidationText);

var _reactAtomLabel = require('@s-ui/react-atom-label');

var _reactAtomLabel2 = _interopRequireDefault(_reactAtomLabel);

var _reactAtomHelpText = require('@s-ui/react-atom-help-text');

var _reactAtomHelpText2 = _interopRequireDefault(_reactAtomHelpText);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-MoleculeField';

var MoleculeField = function (_Component) {
  (0, _inherits3.default)(MoleculeField, _Component);

  function MoleculeField() {
    (0, _classCallCheck3.default)(this, MoleculeField);
    return (0, _possibleConstructorReturn3.default)(this, (MoleculeField.__proto__ || (0, _getPrototypeOf2.default)(MoleculeField)).apply(this, arguments));
  }

  (0, _createClass3.default)(MoleculeField, [{
    key: 'getClassNames',
    value: function getClassNames(inline) {
      return (0, _classnames2.default)(BASE_CLASS, inline && BASE_CLASS + '--inline');
    }
  }, {
    key: 'getTypeValidation',
    value: function getTypeValidation(element) {
      if (this.props.errorText) {
        if (element === 'label') return _reactAtomLabel.AtomLabelTypes.ERROR;
        if (element === 'validationText') return _reactAtomValidationText.AtomValidationTextTypes.ERROR;
      }
      if (this.props.successText) {
        if (element === 'label') return _reactAtomLabel.AtomLabelTypes.SUCCESS;
        if (element === 'validationText') return _reactAtomValidationText.AtomValidationTextTypes.SUCCESS;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          label = _props.label,
          helpText = _props.helpText,
          name = _props.name,
          inline = _props.inline,
          successText = _props.successText,
          errorText = _props.errorText,
          onClickLabel = _props.onClickLabel,
          children = _props.children;

      return _react2.default.createElement(
        'div',
        { className: this.getClassNames(inline) },
        _react2.default.createElement(_reactAtomLabel2.default, {
          type: this.getTypeValidation('label'),
          name: name,
          text: label,
          onClick: onClickLabel
        }),
        _react2.default.createElement(
          'div',
          null,
          children,
          (successText || errorText) && _react2.default.createElement(_reactAtomValidationText2.default, {
            type: this.getTypeValidation('validationText'),
            text: this.statusValidationText
          }),
          helpText && _react2.default.createElement(_reactAtomHelpText2.default, { text: helpText })
        )
      );
    }
  }, {
    key: 'statusValidationText',
    get: function get() {
      if (this.props.errorText) return this.props.errorText;
      if (this.props.successText) return this.props.successText;
    }
  }]);
  return MoleculeField;
}(_react.Component);

MoleculeField.displayName = 'MoleculeField';

MoleculeField.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /** Text to be displayed as label of the textarea */
  label: _propTypes2.default.string.isRequired,

  /** used as for attribute. Must be the same as the input element id */
  name: _propTypes2.default.string.isRequired,

  /** Success message to display when success state  */
  successText: _propTypes2.default.string,

  /** Error message to display when error state  */
  errorText: _propTypes2.default.string,

  /** Help Text to display */
  helpText: _propTypes2.default.string,

  /** Boolean to decide if elements should be set inline */
  inline: _propTypes2.default.bool,

  /** Boolean to decide if elements should be set inline */
  onClickLabel: _propTypes2.default.func
} : {} : {};

exports.default = MoleculeField;